(function() {
  var ceri, getIcon, getIcons;

  getIcons = function() {};

  getIcons();

  if (process.env.NODE_ENV !== 'production' && (typeof getIcon === "undefined" || getIcon === null)) {
    console.error("icon-loader wasn't called - please see ceri-icons documentation on how to setup webpack");
    getIcon = function(name1, name2) {
      return console.error("vue-icons isn't setup properly - failed to get " + name1 + "-" + name2);
    };
  }

  ceri = require("ceri/lib/wrapper");

  module.exports = ceri({
    isCeriIcon: true,
    mixins: [require("ceri/lib/structure"), require("ceri/lib/svg"), require("ceri/lib/styles"), require("ceri/lib/props"), require("ceri/lib/util"), require("ceri/lib/#show")],
    structure: function(){return [this.el("svg",{"version":{"":"1.1"},"role":{":":"role"},"show":{"#":{"val":"icon","mods":{"delay":true}}},"aria-label":{":":"label"},"width":{"":"0",":":"outerWidth"},"height":{"":"0",":":"outerHeight"},"view-box":{":":{"val":"box","mods":{"camel":true}}}},[this.el("path",{"d":{":":"icon.d"},"transform":{":":"flipped"},"fill":{"":"currentColor"}},[])]),"default"]}




,
    props: {
      name: String,
      size: Number,
      scale: {
        type: Number,
        "default": 1
      },
      offsetX: {
        type: Number,
        "default": 0
      },
      offsetY: {
        type: Number,
        "default": 0
      },
      flipH: Boolean,
      flipV: Boolean,
      label: String,
      hcenter: Boolean
    },
    initStyle: {
      display: "inline-block"
    },
    styles: {
      "this": {
        computed: function() {
          return {
            height: this.outerHeight + "px",
            position: this.position,
            left: this.stackParent ? 0 : null
          };
        }
      }
    },
    data: function() {
      return {
        isStack: false,
        stackParent: false
      };
    },
    connectedCallback: function() {
      var child, i, len, ref, results;
      this._stackChildren = [];
      ref = this.children;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        child = ref[i];
        if (child.isCeriIcon) {
          child.stackParent = this;
          this._stackChildren.push(child);
          results.push(this.isStack = true);
        } else {
          results.push(void 0);
        }
      }
      return results;
    },
    computed: {
      role: function() {
        if (this.label) {
          return 'img';
        } else {
          return 'presentation';
        }
      },
      position: function() {
        if (this.isStack) {
          return "relative";
        }
        if (this.stackParent) {
          return "absolute";
        }
        return null;
      },
      processedName: function() {
        var set, tmp;
        if (!this.name) {
          return null;
        }
        tmp = this.name.split("-");
        set = tmp.shift();
        return [set, tmp.join("-")];
      },
      icon: function() {
        if (!this.processedName) {
          return null;
        }
        return getIcon(this.processedName[0], this.util.camelize(this.processedName[1]));
      },
      box: function() {
        var h, hOffset, s, w, wOffset;
        if (!(this.heightRatio && this.icon)) {
          return null;
        }
        w = this.icon.w;
        h = this.icon.h;
        wOffset = -w * ((this.widthRatio - 1) / 2 + this.offsetX / 100);
        hOffset = -h * ((this.heightRatio - 1) / 2 - this.offsetY / 100);
        if (this.flipV) {
          s = "-" + (w + wOffset) + " ";
        } else {
          s = wOffset + " ";
        }
        if (this.flipH) {
          s += "-" + (h + hOffset) + " ";
        } else {
          s += hOffset + " ";
        }
        return s + ((w * this.widthRatio) + " " + (h * this.heightRatio));
      },
      aspect: function() {
        if (!this.icon) {
          return null;
        }
        return this.icon.w / this.icon.h;
      },
      innerWidth: function() {
        return this.aspect * this.innerHeight;
      },
      outerWidth: function() {
        var child, cw, i, len, ref, w;
        if (this.stackParent) {
          return this.stackParent.outerWidth;
        }
        w = this.innerWidth;
        if (this.isStack) {
          ref = this._stackChildren;
          for (i = 0, len = ref.length; i < len; i++) {
            child = ref[i];
            cw = child.innerWidth * (1 + Math.abs(child.offsetX) / 50);
            w = Math.max(cw, w);
          }
        }
        return w;
      },
      widthRatio: function() {
        return this.outerWidth / this.innerWidth;
      },
      innerHeight: function() {
        if (this.size != null) {
          return this.size * this.scale;
        } else {
          return parseFloat(window.getComputedStyle(this).getPropertyValue("font-size").replace("px", "")) * this.scale;
        }
      },
      outerHeight: function() {
        var ch, child, h, i, len, ref;
        if (this.stackParent) {
          return this.stackParent.outerHeight;
        }
        if (this.hcenter) {
          return this.parentElement.clientHeight;
        }
        h = this.innerHeight;
        if (this.isStack) {
          ref = this._stackChildren;
          for (i = 0, len = ref.length; i < len; i++) {
            child = ref[i];
            ch = child.innerHeight * (1 + Math.abs(child.offsetY) / 50);
            h = Math.max(ch, h);
          }
        }
        return h;
      },
      heightRatio: function() {
        return this.outerHeight / this.innerHeight;
      },
      flipped: function() {
        if (!(this.flipH || this.flipV)) {
          return null;
        }
        return "scale(" + (-this.flipV * 2 + 1) + "," + (-this.flipH * 2 + 1) + ")";
      }
    }
  });

}).call(this);
